/**
 * Created by Matt Kucic on 4/14/2014.
 */
var _stage;
var _titlescreen;
var _loading;
var _gameQueue;
var _introAudio;
var _gameConfig;
var hidden, visibilityChange;
var _last_mousedown_time;
var _last_click_time;
var _last_mouseup_time;
var _ua = navigator.userAgent.toLowerCase();
var _isAndroid = _ua.indexOf("android") > -1;
var _isChrome = _ua.indexOf("chrome") > -1;
var _debugData = "";

//android mousetouch check
var _lastMouseDown;
var _minMouseWait = 500;
function isTouchAllowed(){
    var now = new Date().getTime();
    if(_lastMouseDown != undefined){
        if(now - _lastMouseDown < _minMouseWait){
            _lastMouseDown = now;
            return false;
        }
    }
    _lastMouseDown = now;
    return true;
}

function loadGame(){

    fpsDiv = document.getElementById("fps");
    fpsDiv.style.pixelWidth = 800+"px";
    fpsDiv.style.pixelHeight = 50+"px";

    _stage = new createjs.Stage("gameCanvas");
    _stage.enableMouseOver(60);
    createjs.Touch.enable(_stage, true);

    createjs.Ticker.timingMode = createjs.Ticker.RAF_SYNCHED;
    createjs.Ticker.setFPS(30);
    createjs.Ticker.addEventListener("tick", update);

    _gameQueue = new createjs.LoadQueue();
    _gameQueue.on("complete", continueLoad);
    _gameQueue.loadFile({id:"loadData", src:"assets/img/global/trolley_load.json"});

    // // Removing, since springroll Container handles this part
    // //window.addEventListener('pageshow', pageShowHandler, false);
    // //window.addEventListener('pagehide', pageHideHandler, false);
    // if (typeof document.hidden !== "undefined") { // Opera 12.10 and Firefox 18 and later support
    //     hidden = "hidden";
    //     visibilityChange = "visibilitychange";
    // } else if (typeof document.mozHidden !== "undefined") {
    //     hidden = "mozHidden";
    //     visibilityChange = "mozvisibilitychange";
    // } else if (typeof document.msHidden !== "undefined") {
    //     hidden = "msHidden";
    //     visibilityChange = "msvisibilitychange";
    // } else if (typeof document.webkitHidden !== "undefined") {
    //     hidden = "webkitHidden";
    //     visibilityChange = "webkitvisibilitychange";
    // }
    // // Warn if the browser doesn't support addEventListener or the Page Visibility API
    // if (typeof document.addEventListener === "undefined" ||
    //     typeof hidden === "undefined") {
    //     //alert("This demo requires a browser, such as Google Chrome or Firefox, that supports the Page Visibility API.");
    // } else {
    //     // Handle page visibility change
    //     document.addEventListener(visibilityChange, handleVisibilityChange, false);
    // }
}

function continueLoad(){
    _gameQueue.removeAllEventListeners();

    var loadSheet = new createjs.SpriteSheet(_gameQueue.getResult("loadData"));
    _loading = new createjs.Sprite(loadSheet);
    _loading.play();
    _stage.addChild(_loading);

    var busted_json = "assets/config.json".concat("?").concat(Math.floor(Math.random()*10000000).toString());

    _gameQueue.on("complete", onConfigLoad, this);
    _gameQueue.loadFile({id:"configData", src:busted_json});
}

function onConfigLoad() {
    _gameQueue.removeAllEventListeners();

    _gameConfig = _gameQueue.getResult("configData");

    createjs.Sound.alternateExtensions = ["ogg"];
    _gameQueue.installPlugin(createjs.Sound);
    _gameQueue.loadManifest(_gameConfig);
    _gameQueue.on("complete", preloadComplete, this);
    _gameQueue.load();
}

function preloadComplete(evt){
    _gameQueue.removeAllEventListeners("complete");
    _titlescreen = new createjs.Bitmap(_gameQueue.getResult("titlescreen"));
    _playButton = new createjs.Bitmap(_gameQueue.getResult("playButton"));
    _playButton.x = _gameConfig.playButton.x;
    _playButton.y = _gameConfig.playButton.y;
    _playButton.alpha = 0.01;
    _playButton.addEventListener("mouseover", overPlayButton, this);
    _playButton.on("mousedown", onTitleClick, this);

    gameInit(showTitle);
}

function overPlayButton(evt){
    _playButton.removeAllEventListeners();
    _playButton.addEventListener("mouseout", offPlayButton, this);
    _playButton.addEventListener("mousedown", onTitleClick, this);
    _playButton.alpha = 1;
}

function offPlayButton(evt){
    _playButton.removeAllEventListeners();
    _playButton.addEventListener("mouseover", overPlayButton, this);
    _playButton.alpha = 0.01;
}

function showTitle(){
    _loading.stop();
    _stage.removeChild(_loading);
    _loading = null;
    _stage.addChild(_titlescreen);
    _stage.addChild(_playButton);
    _introAudio = window.playVO("intro");
    _titlescreen.addEventListener("mousedown", onTitleClick, this);
}

function onTitleClick(evt){
    _titlescreen.removeAllEventListeners();
    _playButton.removeAllEventListeners();
    app.voPlayer.stop("intro");
    _introAudio = null;
    _stage.removeChild(_playButton);
    _stage.removeChild(_titlescreen);
    _titlescreen = null;
    startGame();
}
/**
 * Created by Matt Kucic on 5/14/2014.
 */
var _gameId = "sandcastle";
var _lastMouseDown;
var _minMouseWait = 500;

function gameInit(callback){
    this.loadedCallback = callback;
    this.minWaitForPiece = _gameConfig.minWait*1000;
    this.maxWaitForPiece = _gameConfig.maxWait*1000;
    this.timeWaiting = 0;
    this.pieceOut = false;

    //this.character = new DBCharacterCJS("dandan", "assets/character/", "Dan_Sandcastle", createjs.proxy(onCharacterReady, this));

    if(_ua.indexOf("android") > -1) {
        this.character = new DBCharacterCJS("dandan", "assets/character_simple/", "Dan_Sandcastle", createjs.proxy(onSCCharacterReady, this));
    }
    else{
        this.character = new DBCharacterCJS("dandan", "assets/character/", "Dan_Sandcastle", createjs.proxy(onSCCharacterReady, this));
    }

    this.holdingDanielsPiece = false;
    this.numberOfWaves = 0;
    this.dadAudioIndex = 0;
    this.storedTime = 0;
    this.danielPieceAudioIndex = 0;
    this.danielClickAudioIndex = 0;
    this.danielOfferAudioIndex = 0;
    this.danielOfferPieceIndex = 0;
    this.waveTimer = 4000;
    this.eraseWaveTimer = -2000;
    this.eraseWaves = 0;
    this.danielWaveResponse = true;
    this.totalPiecesPlaced = 0;
    _stage.pieceAttachedToMouse = false;
}

function onSCCharacterReady(){
    dragonBones.animation.WorldClock.clock.add(this.character.armature);
    playAnimation("idle", "idle", true);
    this.loadedCallback();
}



function onBGTouch(evt){
    if(isTouchAllowed()){
        if(isInside(evt.stageX, evt.stageY,_gameConfig.hitboxes.dad)){
            if(this.danielAudio != undefined ){
                if(this.danielAudio.playState == createjs.Sound.PLAY_FINISHED){
                    if(this.dadAudio != undefined ){
                        if(this.dadAudio.playState == createjs.Sound.PLAY_FINISHED){
                            this.dadAudio = app.sfxPlayer.play(_gameConfig.dadAudio[this.dadAudioIndex]);
                            this.dadAudioIndex ++;
                        }
                    }
                    else {
                        this.dadAudio = app.sfxPlayer.play(_gameConfig.dadAudio[this.dadAudioIndex]);
                        this.dadAudioIndex++;
                    }
                    if(this.dadAudioIndex >= _gameConfig.dadAudio.length){
                        this.dadAudioIndex = 0;
                    }
                }
            }
            else{
                if(this.dadAudio != undefined ){
                    if(this.dadAudio.playState == createjs.Sound.PLAY_FINISHED){
                        this.dadAudio = app.sfxPlayer.play(_gameConfig.dadAudio[this.dadAudioIndex]);
                        this.dadAudioIndex ++;
                    }
                }
                else {
                    this.dadAudio = app.sfxPlayer.play(_gameConfig.dadAudio[this.dadAudioIndex]);
                    this.dadAudioIndex++;
                }
                if(this.dadAudioIndex >= _gameConfig.dadAudio.length){
                    this.dadAudioIndex = 0;
                }
            }
        }
    }

}

function onTouchStart(evt) {
    _stage.addChild(new createjs.Text(evt));
    this.touchShape.graphics.f("#fff").dc(50, 50, 50);
}

function onDanPlaySucceed(evt){
    this.debugData = evt.target.playState.concat(" ").concat(evt.target.src);
}

function onDanPlayComplete(evt){
    this.debugData = evt.target.playState.concat(" ").concat(evt.target.src);
}

function startGame(){
    this.danielAudio = window.playVO("playButtonAudio", true, true);
    this.danielAudio.on("succeeded", createjs.proxy(onDanPlaySucceed));
    this.danielAudio.on("complete", createjs.proxy(onDanPlayComplete));
    this.danielAudio.play();
    playAnimation("intro", "idle", true);

    this.ready = true;
    var bg = new createjs.Bitmap(_gameQueue.getResult("bg"));
    _stage.addChild(bg);
    bg.on("mousedown", createjs.proxy(onBGTouch, this));
    bg.on("touchstart", createjs.proxy(onTouchStart, this));

    this.moat = new DTMoat();
    _stage.addChild(this.moat);

    this.waves = {};

    this.danielLayer = new createjs.Container();
    _stage.addChild(this.danielLayer);
    this.character.x = 700;
    this.character.y = 220;
    this.danielLayer.addChild(this.character);
    var danHitData = _gameConfig.hitboxes.daniel;
    //this.danHitbox = new createjs.Bitmap(_gameQueue.getResult("danHitbox"));
    //this.danHitbox = new createjs.Shape();
    //this.danHitbox.graphics.f("#ffffff").dr(0,0,danHitData.width,danHitData.height);
    //this.danHitbox.alpha = 0.01;
    //this.danHitbox.x = danHitData.x;
    //this.danHitbox.y = danHitData.y;
    //_stage.addChild(this.danHitbox);
    //this.danHitbox.on("mousedown", createjs.proxy(onCharacterTouch, this));
    this.character.on("mousedown", createjs.proxy(onCharacterTouch, this));

    this.pieces = [];
    this.piecesLayer = new createjs.Container();
    _stage.addChild(this.piecesLayer);
	
    this.bucketLayer = new createjs.Container();
    _stage.addChild(this.bucketLayer);

    for(var i=0;i<_gameConfig.castlePieces.length;i++){
        var pieceData = _gameConfig.castlePieces[i];
        switch(pieceData.type){
            case "bucket":
                var newBucket = new DTBucket(pieceData.link, createjs.proxy(placeBucket, this));
                newBucket.setDefaultPosition(pieceData.x, pieceData.y, true);
                this.bucketLayer.addChild(newBucket);
                break;
            case "accoutrement":
                var newAccoutrement = new DTAccoutrement(pieceData.link, createjs.proxy(placeAccoutrement, this));
                newAccoutrement.setDefaultPosition(pieceData.x, pieceData.y, true);
                this.bucketLayer.addChild(newAccoutrement);
                break;
            case "interactive":
                if(pieceData.link == "crab"){
                    this.crab = new DTCrab();
                    this.crab.setStartPoint(pieceData.x,pieceData.y);
                    this.crab.setEndPoint(pieceData.goalX,pieceData.goalY, true);
                    this.crab.setTime(pieceData.time);
                    this.crab.x = this.crab.startPoint.x;
                    this.crab.y = this.crab.startPoint.y;
                    this.bucketLayer.addChild(this.crab);
                }
        }
    }

    this.uiLayer = new createjs.Container();
    _stage.addChild(this.uiLayer);



    this.currentTouches = [];
    this.touchShape = new createjs.Shape();
    _stage.addChild(this.touchShape);

    this.waveButton = new createjs.Bitmap(_gameQueue.getResult("waveButton"));
    this.waveButtonDown = new createjs.Bitmap(_gameQueue.getResult("waveButtonDown"));
    this.waveButton.x = 10;
    this.waveButton.y = 10;
    this.waveButtonDown.x = 10;
    this.waveButtonDown.y = 10;
    this.waveButtonDown.alpha = 0.01;
    this.waveButtonDown.addEventListener("mousedown", createjs.proxy(sendEraseWave, this));
    this.waveButtonDown.addEventListener("pressup", createjs.proxy(resetWaveButton, this));
    this.uiLayer.addChild(this.waveButton);
    this.uiLayer.addChild(this.waveButtonDown);
    //makeWave();

    //initial castle

    var newPiece = new DTSandcastlePiece("purple_sand");
    newPiece.x = 218;
    newPiece.y = 170;
    this.piecesLayer.addChild(newPiece);
    this.pieces.push(newPiece);

    newPiece = new DTSandcastlePiece("yellow_sand");
    newPiece.x = 120;
    newPiece.y = 80;
    this.piecesLayer.addChild(newPiece);
    this.pieces.push(newPiece);

    newPiece = new DTSandcastlePiece("yellow_sand");
    newPiece.x = 370;
    newPiece.y = 110;
    this.piecesLayer.addChild(newPiece);
    this.pieces.push(newPiece);

    newPiece = new DTSandcastlePiece("green_sand");
    newPiece.x = 400;
    newPiece.y = 330;
    this.piecesLayer.addChild(newPiece);
    this.pieces.push(newPiece);


}

function onCharacterTouch(evt){
    if(isTouchAllowed()){
        // this.waveButton.x += 10;
        if(this.pieceOut){
            //attachPiece();
        }
        else{
            if(canPlayAudio()){
                var data = _gameConfig.danielAudio.touched[this.danielClickAudioIndex];
                this.danielClickAudioIndex ++;
                if(this.danielClickAudioIndex>=_gameConfig.danielAudio.touched.length){
                    this.danielClickAudioIndex = 0;
                }
                this.danielAudio = window.playVO(data.audio, true);
                playAnimation(data.animation, "idle", true);
            }
        }
    }
}

function canPlayAudio(){
    //this.debugData = this.danielAudio.playState;
    if(this.danielAudio == undefined){
        return true;
    }
    else if(this.danielAudio.playState == createjs.Sound.PLAY_FINISHED){
        return true;
    }
    return false;
}

function placeBucket(id, posx, posy){
    if(ptInHitbox(posx,posy)){
        var newPiece = new DTSandcastlePiece(id+"_sand");
        newPiece.setPosition(posx,posy);
        newPiece.setDimensions(_gameConfig.dimensions[id+"_sand"]);
        newPiece.offsetImage(0.5,0.8);
        this.piecesLayer.addChild(newPiece);
        this.pieces.push(newPiece);
        this.totalPiecesPlaced++;
        //this.sandPlaceSnd.play();
        app.sfxPlayer.play("item_place");
        if((this.totalPiecesPlaced)%8 == 0){
            if(canPlayAudio()){
                if(this.danielAudio != undefined){
                    this.danielAudio.stop();
                }
                var data = _gameConfig.danielAudio.smalltalk[this.danielPieceAudioIndex];
                this.danielPieceAudioIndex ++;
                if(this.danielPieceAudioIndex >= _gameConfig.danielAudio.smalltalk.length){
                    this.danielPieceAudioIndex = 0;
                }
                this.danielAudio = window.playVO(data.audio, true);
                playAnimation(data.animation, "idle", true);
            }
        }
    }
    else{
        //this.itemReturnSnd.play();
        app.sfxPlayer.play("item_place");
    }
}

function placeDansPiece(id, posx, posy){
    this.bucketLayer.removeChild(this.dansAccoutrement);
    if(this.dansAccoutrement.distanceMoved > 20){
        if(ptInHitbox(posx,posy)) {
            placeAccoutrement(id, posx, posy);
            this.pieceOut = false;
        }
        else{
            this.pieceOut = true;
            this.timeWaiting = 0;
            offerPiece(id, false);
        }
    }
    else{
        this.pieceOut = true;
        this.timeWaiting = 0;
        offerPiece(id, false);
    }
    this.dansAccoutrement = null;
}

function setupPieceListeners(evt){
    var piece = evt.target;
    piece.on(DTSandcastlePiece.PLACED, createjs.proxy(pieceMoved, this));
    piece.setMovable(true);
}

function placeAccoutrement(id, posx, posy){
    if(ptInHitbox(posx,posy)) {
        var newPiece = new DTSandcastlePiece(id);
        newPiece.setDimensions(_gameConfig.dimensions[id]);
        createjs.Tween.get(newPiece).to({timerProxy:1}, 500).call(createjs.proxy(setupPieceListeners, this));
        newPiece.x = posx;
        newPiece.y = posy;
        this.holdingDanielsPiece = false;
        //this.itemPlaceSnd.play();
        app.sfxPlayer.play("sand_place_alt");
        this.piecesLayer.addChild(newPiece);
        this.pieces.push(newPiece);
        this.totalPiecesPlaced++;
        if(this.totalPiecesPlaced%8 == 0){
            if(canPlayAudio()){
                if(this.danielAudio != undefined){
                    this.danielAudio.stop();
                }
                var data = _gameConfig.danielAudio.smalltalk[this.danielPieceAudioIndex];
                this.danielPieceAudioIndex ++;
                if(this.danielPieceAudioIndex >= _gameConfig.danielAudio.smalltalk.length){
                    this.danielPieceAudioIndex = 0;
                }
                this.danielAudio = window.playVO(data.audio, true);
                playAnimation(data.animation, "idle", true);
            }
        }
    }
    else{
        //this.itemReturnSnd.play();
        app.sfxPlayer.play("item_place");
    }
}

function playAnimation(animationID, nextId, loopNext){
    this.character.armature.removeAllEventListeners();
    this.character.armature.animation.gotoAndPlay(animationID);
    if(nextId != undefined){
        if(loopNext){
            this.character.armature.addEventListener(dragonBones.events.AnimationEvent.COMPLETE, createjs.proxy(loopAnimation, this, nextId));
        }
        else{
            this.character.armature.addEventListener(dragonBones.events.AnimationEvent.COMPLETE, createjs.proxy(playNextAnimation, this, nextId));
        }
    }
}

function loopAnimation(evt, animId){
    this.character.armature.removeAllEventListeners();
    this.character.armature.animation.gotoAndPlay(animId);
    this.character.armature.addEventListener(dragonBones.events.AnimationEvent.COMPLETE, createjs.proxy(loopAnimation, this, animId));

}

function playNextAnimation(evt, animId){
    this.character.armature.removeAllEventListeners();
    this.character.armature.animation.gotoAndPlay(animationID);
}

function gotoNext(evt, animID, loop){
    playAniamtion(animID, undefined, true);
}

function pieceMoved(evt){
    if(!ptInHitbox(evt.target.x,evt.target.y)){
        evt.target.x = evt.target.originalPosition.x;
        evt.target.y = evt.target.originalPosition.y;
        //this.itemReturnSnd.play();
        app.sfxPlayer.play("item_place");
    }
    else{
        //this.itemPlaceSnd.play();
        app.sfxPlayer.play("sand_place_alt");
    }
}

function ptInHitbox(px,py){
    for(var i = 0;i<_gameConfig.hitboxes.sandboxes.length;i++){
        if(isInside(px,py,_gameConfig.hitboxes.sandboxes[i])){
            return true;
        }
    }
    return false;
}

function checkForErase(xPos,yPos){
    for(var i = this.pieces.length-1;i>=0;i--){
        if(this.pieces[i].checkCollision(xPos, yPos)){
            this.pieces[i].erase();
            this.pieces[i] = null;
            this.pieces.splice(i,1);
            break;
        }
    }
}

function sendEraseWave(evt){
    if(isTouchAllowed()){
        this.waveButtonDown.alpha = 1;
        this.danielWaveResponse = false;
        makeWave(1);
    }
}

function resetWaveButton(evt){
    this.waveButtonDown.alpha = 0.01;
}

function makeWave(distance){
    if(this.numberOfWaves < 5){
        var newWave = new DTWave(distance);
        newWave.on(DTWave.ERASE_ALL, createjs.proxy(eraseAll, this));
        this.waves[newWave.id] = newWave;
        newWave.on(DTWave.COMPLETE, createjs.proxy(onWaveComplete,this));
        this.piecesLayer.addChildAt(newWave, 0);
        newWave.animate();
        this.numberOfWaves ++;
    }
}

function eraseAll(evt){
    evt.target.removeAllEventListeners(DTWave.ERASE_ALL);
    if(this.danielWaveResponse){
        if(this.danielAudio != undefined){
            this.danielAudio.stop();
        }
        var data = _gameConfig.danielAudio.water[0];
        this.danielAudio = window.playVO(data.audio, true);
        playAnimation(data.animation, "idle", true);
        if(this.dansPiece != undefined){
            this.dansPiece.removeAllEventListeners();
            this.dansPiece = null;
            this.pieceOut = false;
            this.timeWaiting = 0;
        }
    }
    for(var i = this.pieces.length-1; i>=0;i--){
        this.pieces[i].active = false;
        this.pieces[i].erase();
        this.pieces.splice(i,1);
    }
    this.moat.fillMoat();
    this.danielWaveResponse = false;
}

function offerPiece(id, staySilent){

    var offerData = _gameConfig.danielAudio.offers[this.danielOfferAudioIndex];
    this.danielOfferAudioIndex ++;
    if(this.danielOfferAudioIndex >= _gameConfig.danielAudio.offers.length){
        this.danielOfferAudioIndex = 0;
    }
    if(id == undefined){
        id = _gameConfig.danielPieces[this.danielOfferPieceIndex].link;
        this.danielOfferPieceIndex ++;
        if(this.danielOfferPieceIndex >= _gameConfig.danielPieces.length){
            this.danielOfferPieceIndex = 0;
        }
    }

    this.dansPiece = new createjs.Container();
    var dansPieceBMP = new createjs.Bitmap(_gameQueue.getResult(id));
    this.dansPiece.addChild(dansPieceBMP);
    var grabber = new createjs.Shape();
    grabber.alpha = 0.01;
    grabber.graphics.beginFill("#fff").drawRect(0,0,dansPieceBMP.image.width, dansPieceBMP.image.height);
    this.dansPiece.addChild(grabber);
    this.dansPiece.id = id;
    this.dansPiece.on("mousedown", createjs.proxy(onDanielPieceDown, this));
    this.character.armature.getSlot("decoration").setDisplayList(new Array(this.dansPiece));

    if(staySilent == undefined){
        this.danielAudio = window.playVO(offerData.audio);
        playAnimation(offerData.animation, "present_deco_idle", true);
    }
    else{
        playAnimation("present_deco_idle");
    }
    this.pieceOut = true;
}

function onDanielPieceDown(evt){
    if(isTouchAllowed()){
        this.dansPiece.removeAllEventListeners("mousedown");
        this.character.armature.getSlot("decoration").setDisplayList([]);
        this.dansAccoutrement = new DTAccoutrement(this.dansPiece.id, createjs.proxy(placeDansPiece, this));
        this.dansAccoutrement.playPickup();
        this.dansAccoutrement.originalPos = {"x":evt.stageX,"y":evt.stageY};
        this.bucketLayer.addChild(this.dansAccoutrement);
        this.dansAccoutrement.forceMovement(evt);
        this.dansPiece = undefined;
        playAnimation("idle", "idle", true);

        this.holdingDanielsPiece = true;
    }
}

function onWaveComplete(evt){
    evt.target.removeAllEventListeners(DTWave.COMPLETE);
    this.piecesLayer.removeChild(evt.target);
    this.waves[evt.target.id].destroy();
    this.waves[evt.target.id] = null;
    delete this.waves[evt.target.id];
    this.numberOfWaves --;
}

var lastLoop = new Date();

function update(e){

    if(createjs.Ticker.paused) return;

    _stage.canvas.width = _stage.canvas.width;
    var thisLoop = e.runTime;
    var timePassed = thisLoop - lastLoop;
    var fps = Math.round(1000 / (thisLoop - lastLoop));
    while(fpsDiv.childNodes.length >= 1) {
        fpsDiv.removeChild(fpsDiv.firstChild);
    }
    fpsDiv.appendChild(fpsDiv.ownerDocument.createTextNode(fps.toString()));
    lastLoop = thisLoop;
    if(fps < 10){
        this.storedTime += 1/fps;
    }
    else{
        dragonBones.animation.WorldClock.clock.advanceTime((1/fps)+this.storedTime);
        this.storedTime = 0;
    }
    _stage.update(e);

    if(!this.pieceOut && this.ready ){
        this.timeWaiting += timePassed;
    }
    if(this.timeWaiting > this.minWaitForPiece){
        if(canPlayAudio()){
            this.pieceOut = true;
            this.timeWaiting = 0;
            offerPiece();
        }
    }

    if(this.numberOfWaves > 0){
        for(var wave in this.waves){
            this.waves[wave].update();
            if(this.pieces.length > 0){
                for(var i = this.pieces.length-1; i>=0;i--){
                    if(this.waves[wave] != null && this.pieces[i].active){
                        if(ptInCircle({"x":this.pieces[i].x,"y":this.pieces[i].y},this.waves[wave].collisionDef)){
                            this.pieces[i].active = false;
                            this.pieces[i].erase();
                            this.pieces.splice(i,1);
                        }
                    }
                }
            }
        }
    }
    if(this.ready){

        this.waveTimer += timePassed;
        this.eraseWaveTimer += timePassed;
        if(this.numberOfWaves <= 1) {
            if(this.waveTimer >= _gameConfig.waveTime){
                makeWave(0.5);
                this.waveTimer = 0;
            }
            if(this.eraseWaveTimer >= _gameConfig.eraseWaveTime){
                this.eraseWaves ++;
                if(this.eraseWaves % 2 != 0 && this.eraseWaves <= 4){
                    this.danielWaveResponse = true;
                    makeWave(1);
                }
                /*
                else{
                    //makeWave(0.8 + ((Math.random() * 0.2) - .1));
                }
                */
                this.eraseWaveTimer = 0;
            }
        }

        this.moat.update();
    }
}
/**
 * Created by Matt Kucic on 4/4/2014.
 */
(function(window) {
    function DBCharacterCJS (id, location, armatureName, readyCallback) {
        this.initialize();
        var __this = this;
        this.id = id;
        this.armatureName = armatureName;        
        this.readyCallback = readyCallback;        

        if (typeof(location) == "string") {

            var loader = new createjs.LoadQueue();
            loader.on("complete", onAssetsLoaded);
            loader.loadFile({id:"textureImage", src:location + "texture.png"}, false);
            loader.loadFile({id:"textureData", src:location + "texture.json"}, false);
            loader.loadFile({id:"skeletonData", src:location + "skeleton.json"}, false);
            loader.load();
        }
        else if (typeof(location) == "object") {
            __this.texData = location.textureData;
            __this.texture = location.texture;
            __this.skeletonData = location.skeletonData;

            build();
        }

        function onAssetsLoaded(event)
        {
            __this.texture = event.target.getResult("textureImage");
            __this.texData = event.target.getResult("textureData");
            __this.skeletonData = event.target.getResult("skeletonData");
            build();
        }

        function build() {
            __this.factory = new dragonBones.factorys.CreateJSFactory();
            __this.factory.addSkeletonData(dragonBones.objects.DataParser.parseSkeletonData(__this.skeletonData));
            __this.factory.addTextureAtlas(new dragonBones.textures.CreateJSTextureAtlas(__this.texture, __this.texData));
            __this.armature = __this.factory.buildArmature(__this.armatureName);
            __this.addChild(__this.armature.getDisplay());
            
            if (readyCallback) {
                readyCallback(__this);
            }
        }
    }

    DBCharacterCJS.prototype = new createjs.Container();

    DBCharacterCJS.prototype.getArmature = function(){
        return this.armature;
    };

    DBCharacterCJS.prototype.getArmatureByName = function(armatureName){
        return this.factory.buildArmature(armatureName);
    };
    DBCharacterCJS.prototype.getID = function(){
        return this.id;
    };
	DBCharacterCJS.prototype.getBounds = function(){
		var bounds = {"x":0,"y":0,"width":0,"height":0};
	};
    DBCharacterCJS.prototype.destroy = function(){
        this.armature.dispose();
        this.armature = null;
        this.texture = null;
        this.texData = null;
        this.skeletonData = null;

    };

    DBCharacterCJS.prototype.Container_initialize = DBCharacterCJS.prototype.initialize;
    DBCharacterCJS.prototype.initialize = function(){
        this.Container_initialize();
    };

    window.DBCharacterCJS = DBCharacterCJS;
}(window));

/**
 * Created by Matt Kucic on 5/14/2014.
 */
(function(window){
    function DTBucket(id, placeHandler){
        this.initialize();
        this.id = id;
        this.placeHandler = placeHandler;
        this.defaultPosition = new createjs.Point(0, 0);

        this.bucket = new createjs.Bitmap(_gameQueue.getResult(id+"_bucket"));
        this.bucketFlip = new createjs.Bitmap(_gameQueue.getResult(id+"_bucket_flip"));
        this.bucketFlip.visible = false;
        this.addChild(this.bucket);
        this.addChild(this.bucketFlip);

        this.on("mousedown", this.onBucketDown, this);
        //this.touchSnd = app.sfxPlayer.play("item_pickup", false, true);
    }

    DTBucket.prototype = new createjs.Container();
    DTBucket.prototype.Container_initialize = DTBucket.prototype.initialize;
    DTBucket.prototype.initialize = function(){
        this.Container_initialize();
    };

    DTBucket.prototype.onBucketDown = function(evt){
        if(isTouchAllowed() && !this.clickAttach){
            this.touchedAt = new Date();
            this.clickAttach = false;
            this.bucket.visible = false;
            this.bucketFlip.visible = true;
            //this.touchSnd.play();
            app.sfxPlayer.play("item_pickup");
            this.x = evt.stageX - (this.bucketFlip.image.width * 0.5);
            this.y = evt.stageY - (this.bucketFlip.image.height * 0.8);
            this.on("pressmove", this.onBucketMove, this);
            this.on("pressup", this.onBucketUp, this);
        }
    };
    DTBucket.prototype.onBucketMove = function(evt){
        if(!this.clickAttach){
            this.x = evt.stageX - (this.bucketFlip.image.width * 0.5);
            this.y = evt.stageY - (this.bucketFlip.image.height * 0.8);
        }
        else{
            this.x = evt.stageX - (this.bucketFlip.image.width * 0.5);
            this.y = evt.stageY - (this.bucketFlip.image.height * 0.8);
        }

    };
    DTBucket.prototype.onBucketUp = function(evt){
        var currentTime = new Date();
        this.removeAllEventListeners("pressmove");
        this.removeAllEventListeners("pressup");
        _stage.removeAllEventListeners("stagemousemove");
        _stage.removeAllEventListeners("stagemouseup");
        if(!createjs.Touch.isSupported() && currentTime.getTime()-this.touchedAt.getTime() <= _gameConfig.waitTime){
            _stage.on("stagemousemove", this.onBucketMove, this);
            _stage.on("stagemouseup", this.onBucketUp, this);
            this.x = evt.stageX - (this.bucketFlip.image.width * 0.5);
            this.y = evt.stageY - (this.bucketFlip.image.height * 0.8);
            _stage.pieceAttachedToMouse = true;
            this.clickAttach = true;
        }
        else{
            if(this.placeHandler != null){
                _stage.pieceAttachedToMouse = false;
                this.placeHandler(this.id, evt.stageX, evt.stageY);
                this.x = this.defaultPosition.x;
                this.y = this.defaultPosition.y;
                this.bucket.visible = true;
                this.bucketFlip.visible = false;
            }
            this.clickAttach = false;
        }
    };

    DTBucket.prototype.setDefaultPosition = function(xPos, yPos, placeNow){
        this.defaultPosition = new createjs.Point(xPos, yPos);
        if(placeNow){
            this.x = this.defaultPosition.x;
            this.y = this.defaultPosition.y;
        }
    };

    DTBucket.prototype.setSaleFactors = function(minY,minScale,maxY,maxScale){
        this.minY = minY;
        this.minScale = minScale;
        this.maxY = maxY;
        this.maxScale = maxScale;
    };

    window.DTBucket = DTBucket;
})(window);
/**
 * Created by Matt Kucic on 5/21/2014.
 */
(function(window){
    function DTAccoutrement(id, placeHandler){
        this.initialize();
        this.id = id;
        this.placeHandler = placeHandler;
        this.defaultPosition = new createjs.Point(0, 0);
        this.piece = new createjs.Bitmap(_gameQueue.getResult(id));
        //this.piece.x = this.piece.image.width * -0.5;
        //this.piece.y = this.piece.image.height * -0.5;
        this.on("mousedown", this.onPieceDown, this);

        this.grabHelper = new createjs.Shape();
        this.grabHelper.graphics.beginFill("#fff").drawRect(this.piece.x, this.piece.y, this.piece.image.width, this.piece.image.height);
        this.grabHelper.alpha = 0.01;
        this.clickAttach = false;
        //this.touchSound = app.sfxPlayer.play("sand_place", false, true);
        this.addChild(this.grabHelper);
        this.addChild(this.piece);
    }

    DTAccoutrement.prototype = new createjs.Container();
    DTAccoutrement.prototype.Container_initialize = DTAccoutrement.prototype.initialize;
    DTAccoutrement.prototype.initialize = function(){
        this.Container_initialize();
    };

    DTAccoutrement.prototype.playPickup = function(){
        //this.touchSound.play();
        app.sfxPlayer.play("sand_place");
    };

    DTAccoutrement.prototype.setDefaultPosition = function(xPos, yPos, placeNow){
        this.defaultPosition = new createjs.Point(xPos, yPos);
        if(placeNow){
            this.x = this.defaultPosition.x;
            this.y = this.defaultPosition.y;
        }
    };

    DTAccoutrement.prototype.onPieceDown = function(evt){
        if(isTouchAllowed() && !this.clickAttach){
            this.touchedAt = new Date();
            //this.touchSound.play();
            app.sfxPlayer.play("sand_place");
            this.clickAttach = false;
            this.x = evt.stageX - (this.piece.image.width * 0.5);
            this.y = evt.stageY - (this.piece.image.height);
            this.originalPos = {"x":this.x,"y":this.y};
            this.on("pressmove", this.onPieceMove, this);
            this.on("pressup", this.onPieceUp, this);
        }
    };

    DTAccoutrement.prototype.onPieceMove = function(evt){
        if(!this.clickAttach){
            this.x = evt.stageX - (this.piece.image.width * 0.5);
            this.y = evt.stageY - (this.piece.image.height);
        }
        else{
            this.x = evt.stageX - (this.piece.image.width * 0.5);
            this.y = evt.stageY - (this.piece.image.height * 0.5);
        }
    };

    DTAccoutrement.prototype.onPieceUp = function(evt){
        var currentTime = new Date();
        this.removeAllEventListeners("pressmove");
        this.removeAllEventListeners("pressup");
        _stage.removeAllEventListeners("stagemousemove");
        _stage.removeAllEventListeners("stagemouseup");
        if(!createjs.Touch.isSupported() && currentTime.getTime()-this.touchedAt.getTime() <= _gameConfig.waitTime){

            _stage.on("stagemousemove", this.onPieceMove, this);
            _stage.on("stagemouseup", this.onPieceUp, this);
            this.x = evt.stageX - (this.piece.image.width * 0.5);
            this.y = evt.stageY - (this.piece.image.height * 0.5);
            _stage.pieceAttachedToMouse = true;
            this.clickAttach = true;

        }
        else{
            if(this.placeHandler != null){
                _stage.pieceAttachedToMouse = false;
                this.distanceMoved = ptToPtDistance(this.originalPos.x, this.originalPos.y, evt.stageX, evt.stageY);
                this.placeHandler(this.id, this.x, this.y);
                this.x = this.defaultPosition.x;
                this.y = this.defaultPosition.y;
            }
            this.clickAttach = false;
        }
    };

    DTAccoutrement.prototype.forceMovement = function(evt){
        this.x = evt.stageX;
        this.y = evt.stageY;
        this.touchedAt = new Date();
        _stage.on("stagemousemove", this.onPieceMove, this);
        _stage.on("stagemouseup", this.onPieceUp, this);
    };

    window.DTAccoutrement = DTAccoutrement;
})(window);
/**
 * Created by Matt Kucic on 5/15/2014.
 */
(function(window){
    function DTSandcastlePiece(fileID, xPos, yPos){
        this.initialize();
        this.fileID = fileID;
        this.id = fileID+Math.floor(new Date().getTime());
        this.image = new createjs.Bitmap(_gameQueue.getResult(fileID));
        this.x = xPos;
        this.y = yPos;
        this.active = true;
        this.clickAttach = false;
        //this.touchSound = app.sfxPlayer.play("sand_place", false, true);
        this.timerProxy = 0;

        this.addChild(this.grabHelper);
        this.addChild(this.image);
    }

    DTSandcastlePiece.prototype = new createjs.Container();

    DTSandcastlePiece.PLACED = "piecePlaced";

    DTSandcastlePiece.prototype.Container_initialize = DTSandcastlePiece.prototype.initialize;
    DTSandcastlePiece.prototype.initialize = function(){
        this.Container_initialize();
    };

    DTSandcastlePiece.prototype.reposition = function (xPos,yPos){
        this.image.x = xPos;
        this.image.y = yPos;
    };

    DTSandcastlePiece.prototype.checkCollision = function(xPos,yPos){
        var rect = new createjs.Rectangle(this.x+this.image.x,this.y+this.image.y,this.artWidth, this.artHeight);
        if(isInside(xPos,yPos,rect)){
            return true;
        }
        return false;
    };

    DTSandcastlePiece.prototype.erase = function(){
        if(this.storedHandler != undefined){
            this.storedHandler.removeAllEventListeners("pressmove");
            this.storedHandler.removeAllEventListeners("pressup");
        }
        //_stage.removeAllEventListeners("stagemousemove");
        //_stage.removeAllEventListeners("stagemouseup");
        createjs.Tween.get(this).to({alpha:0}, 500).call(eraseComplete, null, this);
        function eraseComplete(){
            this.removeChild(this.image);
            this.image = null;
            this.id = null;
        }
    };

    DTSandcastlePiece.prototype.setPosition = function(inX, inY){
        this.x = inX;
        this.y = inY;
    };

    DTSandcastlePiece.prototype.setDimensions = function(dimensions){
        this.artWidth = dimensions.width;
        this.artHeight = dimensions.height;
        this.grabHelper = new createjs.Shape();
        this.grabHelper.graphics.beginFill("#fff").drawRect(this.image.x, this.image.y, this.artWidth, this.artHeight);
        this.grabHelper.alpha = 0.01;
        this.addChild(this.grabHelper);
    };

    DTSandcastlePiece.prototype.offsetImage = function(xOffset, yOffset){
        this.x -= this.artWidth*xOffset;
        this.y -= this.artHeight*yOffset;
    };

    DTSandcastlePiece.prototype.setMovable = function(flag){
        this.on("mousedown", this.onClick, this);

    };

    DTSandcastlePiece.prototype.onClick = function(evt){
        if(isTouchAllowed() && !this.clickAttach){
            this.originalPosition = {"x":this.x, "y":this.y};
            this.touchedAt = new Date();
            //this.touchSound.play();
            app.sfxPlayer.play("sand_place");
            this.clickAttach = false;
            this.parent.addChild(this);
            this.on("pressmove", this.movePiece, this);
            this.on("pressup", this.releasePiece, this);
        }
    };

    DTSandcastlePiece.prototype.movePiece = function(evt){
        if(!this.clickAttach){
            this.x = evt.stageX - (this.artWidth * 0.5);
            this.y = evt.stageY - (this.artHeight);
        }
        else{
            this.x = evt.stageX - (this.artWidth * 0.5);
            this.y = evt.stageY - (this.artHeight * 0.5);
        }
    };

    DTSandcastlePiece.prototype.releasePiece = function(evt){
        var currentTime = new Date();
        if(this.storedHandler) //This variable/property isn't even used?!
        {
            this.storedHandler.removeAllEventListeners();
        }
        _stage.removeAllEventListeners();
        if(!createjs.Touch.isSupported() && currentTime.getTime()-this.touchedAt.getTime() <= _gameConfig.waitTime){
            if(this.clickAttach){
                _stage.pieceAttachedToMouse = false;
                this.clickAttach = false;
                this.dispatchEvent(new createjs.Event(DTSandcastlePiece.PLACED));
            }
            else{
                if(!_stage.pieceAttachedToMouse){
                    _stage.on("stagemousemove", this.movePiece, this);
                    _stage.on("stagemouseup", this.dropPiece, this);
                    this.clickAttach = true;
                    _stage.pieceAttachedToMouse = true;
                }
                this.clickAttach = false;
            }
        }
        else{
            _stage.pieceAttachedToMouse = false;
            this.dropPiece();
        }
    };

    DTSandcastlePiece.prototype.dropPiece = function(evt){
        this.removeAllEventListeners("mousedown");
        _stage.removeAllEventListeners();
        if(this.clickAttach){
            this.clickAttach = false;
            this.timerProxy = 0;
        }
        this.dispatchEvent(new createjs.Event(DTSandcastlePiece.PLACED));
        createjs.Tween.get(this).to({timerProxy:1}, 500).call(this.setMovable, null, this);
    };

    window.DTSandcastlePiece = DTSandcastlePiece;
})(window);
/**
 * Created by Matt Kucic on 5/22/2014.
 */
(function(window){
    function DTWave(inDist){
        this.initialize();
        this.id = "wave"+(Math.floor(Math.random()*1000000));
        this.waveDimensions = _gameConfig.dimensions.wave;
        this.dryout = false;
        this.wave = new createjs.Bitmap(_gameQueue.getResult("wave"));
        //this.heightDif = 500-this.wave.image.height;
        this.heightDif = 500-this.waveDimensions.height;
        this.collisionOffset = {"xOffset":this.waveDimensions.width *0.2,"yOffset":this.waveDimensions.height*1.4};
        var rand = (Math.random()*0.4)-0.2;
        var xOffset = 0;
        var yOffset = 0;
        this.startX = -this.waveDimensions.width+xOffset;
        this.startY = this.waveDimensions.height+yOffset+this.heightDif;
        this.distance = inDist;
        if(this.distance == undefined){
            this.distance = (Math.random()*0.05)+0.45;
        }
        this.endX = (this.waveDimensions.width*this.distance)+this.startX;
        this.endY = (-this.waveDimensions.height*this.distance)+this.startY+this.heightDif;
        this.wave.x = this.startX;
        this.wave.y = this.startY;
        this.collisionDef = {"x":this.startX+this.collisionOffset.xOffset,"y":this.startY+this.collisionOffset.yOffset,"radius":this.waveDimensions.width};
        this.addChild(this.wave);
    }

    DTWave.prototype = new createjs.Container();
    DTWave.COMPLETE = "complete";
    DTWave.ERASE_ALL = "eraseAll";
    DTWave.prototype.Container_initialize = DTWave.prototype.initialize;
    DTWave.prototype.initialize = function(){
        this.Container_initialize();
    };

    DTWave.prototype.animate = function(){
        var sndIndex = Math.floor(_gameConfig.sfx.tide.regular.length*Math.random());
        var sound = app.sfxPlayer.play(_gameConfig.sfx.tide.regular[sndIndex]);
        if(sound != undefined){
            sound.volume = 0.5;
            sound.play();
        }
        createjs.Tween.get(this.wave).to({x:this.endX,y:this.endY},1500,createjs.Ease.quadOut).call(waveIn, null, this);
        createjs.Tween.get(this.collisionDef).to({x:this.endX+this.collisionOffset.xOffset,y:this.endY+this.collisionOffset.yOffset},1500,createjs.Ease.quadOut);
        function waveIn(){
            this.dryout = true;
            if(this.distance == 1){
                this.dispatchEvent(new createjs.Event(DTWave.ERASE_ALL));
            }
            createjs.Tween.get(this.wave).wait(400).to({x:this.startX,y:this.startY},1500,createjs.Ease.quadIn).call(waveOut, null, this);
            createjs.Tween.get(this.collisionDef).wait(400).to({x:this.startX+this.collisionOffset.xOffset,y:this.startY+this.collisionOffset.yOffset},1500,createjs.Ease.quadIn);

        }
        function waveOut(){
            this.dispatchEvent(DTWave.COMPLETE);
        }
    };

    DTWave.prototype.update = function(){

    };

    DTWave.prototype.destroy = function(){

    };

    window.DTWave = DTWave;
})(window);

/**
 * Created by Matt Kucic on 4/10/2014.
 */
 
function isInside(x,y,rect){
    x1 = Math.min(rect.x, rect.x+rect.width);
    x2 = Math.max(rect.x, rect.x+rect.width);
    y1 = Math.min(rect.y, rect.y+rect.height);
    y2 = Math.max(rect.y, rect.y+rect.height);
    if ((x1 <= x && x <= x2) && (y1 <= y && y <= y2)) {
        return true;
    } else {
        return false;
    }
}

function ptInCircle(point, circle){
    if(ptToPtDistance(point.x,point.y,circle.x, circle.y)<= circle.radius){
        return true;
    }
    return false;
}

function ptToPtDistance(x1,y1,x2,y2){
    return Math.sqrt(((x2-x1)*(x2-x1))+((y2-y1)*(y2-y1)));
}

/**
 * Created by Matt Kucic on 6/19/2014.
 */
(function(window){
    function DTMoat(){
        this.initialize();
        this.x = 30;
        this.y = 125;
        this.images = [];
        this.images.push(new createjs.Bitmap());
        this.currentFrame = 0;
        this.state = DTMoat.IDLE;
        this.idleFrames = 0;
        this.counter = 0;
        this.fillLevel = 0;
        this.emptyTick = 0;
        this.waterImage = undefined;
        for(var i=0;i<_gameConfig.moatIds.length;i++){
            this.images.push(new createjs.Bitmap(_gameQueue.getResult(_gameConfig.moatIds[i])));
        }
        this.bg = new createjs.Bitmap(_gameQueue.getResult("moat"));
        this.bg.x = -18;
        this.bg.y = -12;
        this.addChild(this.bg);
    }
    DTMoat.prototype = new createjs.Container();
    DTMoat.FILLING = "filling";
    DTMoat.EMPTYING = "emptying";
    DTMoat.IDLE = "idle";
    DTMoat.IDLE_TIME = 600;
    DTMoat.EMPTY_SPEED = 20;
    DTMoat.FILL_SPEED = 1;
    DTMoat.prototype.Container_initialize = DTMoat.prototype.initialize;
    DTMoat.prototype.initialize = function(){
        this.Container_initialize();
    };

    DTMoat.prototype.fillMoat = function(){
        if(this.fillLevel == 0 || this.state == DTMoat.EMPTYING){
            this.goalFrame = this.images.length-1;
            this.state = DTMoat.FILLING;
            this.fillLevel = this.currentFrame;
            this.idleFrames = 0;
        }
    };
    DTMoat.prototype.emptyMoat = function(){
        this.goalFrame = 0;
        this.state = DTMoat.EMPTYING;
        this.emptyTick = DTMoat.EMPTY_SPEED;
        this.idleFrames = 0;
    };
    DTMoat.prototype.fullFill = function(){
        this.currentFrame = this.images.length-1;
        this.gotoFrame(this.currentFrame);
        this.fillLevel = this.images.length*DTMoat.EMPTY_SPEED;
        this.emptyMoat();
        this.idleFrames = 0;
    };
    DTMoat.prototype.update = function(){
        if(this.currentFrame != this.goalFrame){
            switch(this.state){
                case DTMoat.EMPTYING:
                        this.emptyTick --;
                        if(this.currentFrame > this.goalFrame){
                            if(this.emptyTick == 0){
                                this.currentFrame --;
                                this.fillLevel = this.currentFrame;
                                this.emptyTick = DTMoat.EMPTY_SPEED;
                                this.gotoFrame(this.currentFrame);
                            }
                        }
                    break;
                case DTMoat.FILLING:
                    this.fillLevel ++;
                    if(this.currentFrame < this.goalFrame){
                        if(this.fillLevel%DTMoat.FILL_SPEED == 0){
                            this.currentFrame ++;
                            this.gotoFrame(this.currentFrame);
                        }
                    }
                    if(this.currentFrame == this.goalFrame){
                        this.state = DTMoat.IDLE;
                        this.goalFrame = 0;
                    }
                    break;
                case DTMoat.IDLE:
                    this.idleFrames ++;
                    if(this.idleFrames > DTMoat.IDLE_TIME  && this.fillLevel > 0){
                        this.emptyMoat();
                    }
                    break;
                default:
            }
        }
    };

    DTMoat.prototype.gotoFrame = function(frameNumber){
        if(this.waterImage != undefined){
            this.removeChild(this.waterImage);
        }
        this.waterImage = this.images[frameNumber];

        this.waterImage.scaleX =  2;
        this.waterImage.scaleY = 2;
        this.addChild(this.waterImage);
    };

    window.DTMoat = DTMoat;
})(window);
/**
 * Created by Matt Kucic on 6/23/2014.
 */
(function(window){
    function DTCrab(){
        this.initialize();
        this.crab = new createjs.Sprite(new createjs.SpriteSheet(this.crabData), "hide");
        this.addChild(this.crab);
        this.state = "leaving";
        this.tickCount = 0;
        this.crab.on("mousedown", this.revealCrabby, this);
        /*
        this.crabpopout = app.sfxPlayer.play("crab_popup", false, true);
        this.crabpopout.volume = 0.5;
        this.crabpopin = app.sfxPlayer.play("crab_popin", false, true);
        this.crabpopin.volume = 0.5;
        this.crabwalk = app.sfxPlayer.play("crab_walk_loop", false, true);
        this.crabwalk.volume = 0.5;
        */
    }

    DTCrab.prototype = new createjs.Container();
    DTCrab.UNREVEAL = "unreveal";
    DTCrab.REVEAL = "reveal";
    DTCrab.HIDE = "hide";
    DTCrab.WALK = "walk";
    DTCrab.IDLE = "idle";

    DTCrab.prototype.Container_initialize = DTCrab.prototype.initialize;
    DTCrab.prototype.initialize = function(){
        this.Container_initialize();
        this.crabData = {
            "images": [_gameQueue.getResult("crabSheet")],
            "frames": [
                [2, 2, 124, 124, 0, -6, -2],
                [130, 2, 124, 124, 0, -6, -2],
                [258, 2, 124, 124, 0, -6, -2],
                [386, 2, 124, 124, 0, -6, -2],
                [514, 2, 124, 124, 0, -6, -2],
                [642, 2, 124, 124, 0, -6, -2],
                [770, 2, 124, 124, 0, -6, -2],
                [898, 2, 124, 124, 0, -6, -2],
                [2, 130, 124, 124, 0, -6, -2],
                [130, 130, 124, 124, 0, -6, -2],
                [258, 130, 124, 124, 0, -6, -2],
                [386, 130, 124, 124, 0, -6, -2],
                [514, 130, 124, 124, 0, -6, -2],
                [642, 130, 124, 124, 0, -6, -2],
                [770, 130, 124, 124, 0, -6, -2],
                [898, 130, 124, 124, 0, -6, -2],
                [2, 258, 124, 124, 0, -6, -2],
                [130, 258, 124, 124, 0, -6, -2],
                [258, 258, 124, 124, 0, -6, -2],
                [386, 258, 124, 124, 0, -6, -2],
                [514, 258, 124, 124, 0, -6, -2],
                [642, 258, 124, 124, 0, -6, -2],
                [770, 258, 124, 124, 0, -6, -2],
                [898, 258, 124, 124, 0, -6, -2],
                [2, 386, 124, 124, 0, -6, -2],
                [130, 386, 124, 124, 0, -6, -2],
                [258, 386, 124, 124, 0, -6, -2],
                [386, 386, 124, 124, 0, -6, -2],
                [514, 386, 124, 124, 0, -6, -2],
                [642, 386, 124, 124, 0, -6, -2],
                [770, 386, 124, 124, 0, -6, -2]
            ],
            "animations": {"unreveal": {"frames": [12, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0], next:"hide"}, "reveal": {"frames": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 12], next:"idle"}, "walk": {"frames": [13, 25, 26, 27, 13, 28, 29, 30]}, "idle": {"frames": [13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 11, 12, 13, 13, 13]}, "hide": {"frames": [0]}, "all": {"frames": [0]}}
        };
    };
    DTCrab.prototype.revealCrabby = function(){
        if(isTouchAllowed()){
            this.crab.removeAllEventListeners();
            this.crab.gotoAndPlay(DTCrab.REVEAL);
            //this.crabpopout.play();
            var crabpopout = app.sfxPlayer.play("crab_popup", false, true);
            if(crabpopout != undefined){
                crabpopout.volume = 0.5;
                crabpopout.play();
            }
            this.crab.on("mousedown", this.crabbyLeave, this);
            this.tickCount = 0;
            this.crab.on("tick", this.onTick, this);
        }
    };
    DTCrab.prototype.hideCrabby = function(){
        if(isTouchAllowed()){
            this.crab.removeAllEventListeners();
            createjs.Tween.removeTweens(this);
            this.crab.gotoAndPlay(DTCrab.UNREVEAL);
            //this.crabwalk.stop();
            if(this.crabwalk != undefined){
                this.crabwalk.stop();
            }
            //this.crabpopin.play();
            var crabpopin = app.sfxPlayer.play("crab_popin", false, true);
            if(crabpopin != undefined){
                crabpopin.volume = 0.5;
                crabpopin.play();
            }
            this.crab.on("mousedown", this.revealCrabby, this);
            this.tickCount = 0;
            this.crab.on("tick", this.checkForPopUp, this);
        }

    };
    DTCrab.prototype.crabbyLeave = function(){
        if(isTouchAllowed()){
            this.crab.removeAllEventListeners();
            this.crab.gotoAndPlay(DTCrab.WALK);
            //this.crabwalk.play({loop:Infinity});
            this.crabwalk = app.sfxPlayer.play("crab_walk_loop", false, true);
            if(this.crabwalk != undefined){
                this.crabwalk.volume = 0.5;
                this.crabwalk.play({loop:Infinity});
            }
            this.crab.on("mousedown", this.hideCrabby, this);
            createjs.Tween.get(this).to({"x":this.goalPosition.x,"y":this.goalPosition.y}, this.getTime()).call(this.reachedGoal, this);
        }
    };

    DTCrab.prototype.reachedGoal = function(evt){
        this.crab.removeAllEventListeners();
        if(this.crabwalk != undefined){
            this.crabwalk.stop();
        }
        if(this.state == "leaving"){
            this.tickCount = 0;
            this.goalPosition = this.startPoint;
            this.state = "returning";
            this.crab.on("tick", this.checkForReturn, this);
        }
        else if(this.state == "returning"){
            this.crab.gotoAndPlay(DTCrab.UNREVEAL);
            //this.crabpopin.play();
            var crabpopin = app.sfxPlayer.play("crab_popin", false, true);
            if(crabpopin != undefined){
                crabpopin.volume = 0.5;
                crabpopin.play();
            }
            this.goalPosition = this.endPoint;
            this.state = "leaving";
            this.crab.on("mousedown", this.revealCrabby, this);
        }
    };

    DTCrab.prototype.crabbyGone = function(evt){
        this.crab.removeAllEventListeners();
        this.tickCount = 0;
        this.crab.on("tick", this.checkForReturn, this);

    };
    DTCrab.prototype.crabbyReturned = function(evt){
        this.crab.removeAllEventListeners();
        createjs.Tween.removeTweens(this);
        this.crab.hideCrabby();

    };
    DTCrab.prototype.setStartPoint = function(inX, inY){
       this.startPoint = {"x":inX,"y":inY};
    };
    DTCrab.prototype.setEndPoint = function(inX, inY, setAsGoal){
       this.endPoint = {"x":inX,"y":inY};
        if(setAsGoal){
            this.goalPosition = this.endPoint;
        }
    };
    DTCrab.prototype.setTime = function(time){
       this.moveTime = time;
    };

    DTCrab.prototype.onTick = function(evt){
        this.tickCount ++;
        if(this.tickCount >= 150){
            this.crab.removeAllEventListeners();
            this.crab.gotoAndPlay(DTCrab.UNREVEAL);
            //this.crabpopin.play();
            var crabpopin = app.sfxPlayer.play("crab_popin", false, true);
            if(crabpopin != undefined){
                crabpopin.volume = 0.5;
                crabpopin.play();
            }
            this.crab.on("mousedown", this.revealCrabby, this);
            this.tickCount = 0;
            this.crab.on("tick", this.checkForPopUp, this);
        }
    };
    DTCrab.prototype.checkForReturn = function(evt){
        this.tickCount ++;
        if(this.tickCount >= 600){
            this.crab.removeAllEventListeners();
            this.crab.gotoAndPlay(DTCrab.WALK);
            //this.crabwalk.play({loop:Infinity});
            this.crabwalk = app.sfxPlayer.play("crab_walk_loop", false, true);
            if(this.crabwalk != undefined){
                this.crabwalk.volume = 0.5;
                this.crabwalk.play({loop:Infinity});
            }
            this.crab.on("mousedown", this.hideCrabby, this);
            createjs.Tween.get(this).to({"x":this.goalPosition.x,"y":this.goalPosition.y}, this.getTime()).call(this.reachedGoal, this);
        }
    };
    DTCrab.prototype.checkForPopUp = function(evt){
        this.tickCount ++;
        if(this.tickCount >= 900){
            this.crab.removeAllEventListeners();
            this.crab.gotoAndPlay(DTCrab.REVEAL);
            //this.crabpopout.play();
            var crabpopout = app.sfxPlayer.play("crab_popup", false, true);
            if(crabpopout != undefined){
                crabpopout.volume = 0.5;
                crabpopout.play();
            }
            this.crab.on("mousedown", this.crabbyLeave, this);
            this.tickCount = 0;
            this.crab.on("tick", this.onTick, this);
        }
    };
    DTCrab.prototype.getTime = function(){
        var totalDistance = ptToPtDistance(this.startPoint.x, this.startPoint.x, this.endPoint.x, this.endPoint.y);
        var distanceLeft = ptToPtDistance(this.x, this.y, this.goalPosition.x, this.goalPosition.y);
        return this.moveTime*(distanceLeft/totalDistance);
    };

    window.DTCrab = DTCrab;
})(window);